using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Support.V7.Widget;
using System.Collections.Generic;

namespace RecyclerViewer
{
	[Activity (Label = "RecyclerViewer", MainLauncher = true, Icon = "@drawable/icon", 
               Theme = "@android:style/Theme.Material.Light.DarkActionBar")]
	public class MainActivity : Activity
	{
		RecyclerView mRecyclerView;
		RecyclerView.LayoutManager mLayoutManager;
		PhotoAlbumAdapter mAdapter;

        PhotoAlbum mPhotoAlbum;

		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

            mPhotoAlbum = new PhotoAlbum();
			SetContentView (Resource.Layout.Main);
			mRecyclerView = FindViewById<RecyclerView> (Resource.Id.recyclerView);

			mLayoutManager = new LinearLayoutManager (this);
            mRecyclerView.SetLayoutManager (mLayoutManager);
			mAdapter = new PhotoAlbumAdapter (mPhotoAlbum);
            mAdapter.ItemClick += OnItemClick;
			mRecyclerView.SetAdapter (mAdapter);

            Button randomPickBtn = FindViewById<Button>(Resource.Id.randPickButton);
            randomPickBtn.Click += delegate
            {
                if (mPhotoAlbum != null)
                {
                    //int idx = mPhotoAlbum.RandomSwap();

                    // Update the RecyclerView by notifying the adapter:
                    // Notify that the top and a randomly-chosen photo has changed (swapped):
                    //mAdapter.NotifyItemChanged(0);
                    //mAdapter.NotifyItemChanged(idx);
                }
            };
		}

        void OnItemClick (object sender, int position)
        {
            int photoNum = position + 1;
            Toast.MakeText(this, "This is photo number " + photoNum, ToastLength.Short).Show();
        }
	}
    
}
