﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Support.V7.Widget;
using Android.Util;
using Android.Views;
using Android.Widget;

namespace RecyclerViewer
{
    //----------------------------------------------------------------------
    // ADAPTER

    // Adapter to connect the data set (photo album) to the RecyclerView: 
    public class PhotoAlbumAdapter : RecyclerView.Adapter
    {
        public event EventHandler<int> ItemClick;
        public PhotoAlbum mPhotoAlbum;

        public PhotoAlbumAdapter(PhotoAlbum photoAlbum)
        {
            mPhotoAlbum = photoAlbum;
        }

        public override RecyclerView.ViewHolder OnCreateViewHolder(ViewGroup parent, int viewType)
        {
            View itemView = LayoutInflater.From(parent.Context).Inflate(Resource.Layout.PhotoCardView, parent, false);

            PhotoViewHolder vh = new PhotoViewHolder(itemView, OnClick);
            return vh;
        }

        private Dictionary<int, bool> map = new Dictionary<int, bool>();
        public override void OnBindViewHolder(RecyclerView.ViewHolder holder, int position)
        {
            PhotoViewHolder vh = holder as PhotoViewHolder;

            vh.MyCheckBox.SetOnCheckedChangeListener(new MyListener(map, position));

            //vh.Image.SetImageResource (mPhotoAlbum[position].PhotoID);
            vh.Caption.Text = mPhotoAlbum[position].Caption;
            if (map != null && map.ContainsKey(position))
            {
                vh.MyCheckBox.Checked = true;
            }
            else
            {
                vh.MyCheckBox.Checked = false;
            }
        }

        class MyListener : Java.Lang.Object, CompoundButton.IOnCheckedChangeListener
        {
            public Dictionary<int, bool> map;
            public int mPosotion;

            public MyListener(Dictionary<int, bool> map, int position)
            {
                this.map = map;
                mPosotion = position;
            }

            public void OnCheckedChanged(CompoundButton buttonView, bool isChecked)
            {
                if (isChecked == true)
                {
                    if (!map.ContainsKey(mPosotion))
                    {
                        map.Add(mPosotion, true);
                    }
                }
                else
                {
                    map.Remove(mPosotion);
                }
            }
        }

        public override int ItemCount
        {
            get { return mPhotoAlbum.NumPhotos; }
        }

        // Raise an event when the item-click takes place:
        void OnClick(int position)
        {
            if (ItemClick != null)
                ItemClick(this, position);
        }

    }
}